summaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
authorRanieri Innocenti Spada <56073060+Ranieri93@users.noreply.github.com>2023-04-13 18:29:29 +0200
committerGitHub <noreply@github.com>2023-04-13 16:29:29 +0000
commit5fa84e88661ac505ade404551bb5594e2201926e (patch)
tree515ead71ff856d189e1f9ed8d8a7e0919aeed14d /tools
parentbae4420c03e23ebb83d19008f04f99211e9d996b (diff)
downloadnode-new-5fa84e88661ac505ade404551bb5594e2201926e.tar.gz
tools: automate uvwasi dependency update
Refs: https://github.com/nodejs/security-wg/issues/828 PR-URL: https://github.com/nodejs/node/pull/47509 Reviewed-By: Marco Ippolito <marcoippolito54@gmail.com> Reviewed-By: Michael Dawson <midawson@redhat.com> Reviewed-By: Rafael Gonzaga <rafael.nunu@hotmail.com>
Diffstat (limited to 'tools')
-rw-r--r--tools/dep_updaters/update-uvwasi.sh78
1 files changed, 78 insertions, 0 deletions
diff --git a/tools/dep_updaters/update-uvwasi.sh b/tools/dep_updaters/update-uvwasi.sh
new file mode 100644
index 0000000000..a6a66bf4e7
--- /dev/null
+++ b/tools/dep_updaters/update-uvwasi.sh
@@ -0,0 +1,78 @@
+#!/bin/sh
+set -e
+# Shell script to update uvwasi in the source tree to a specific version
+
+BASE_DIR=$(cd "$(dirname "$0")/../.." && pwd)
+DEPS_DIR="$BASE_DIR/deps"
+
+[ -z "$NODE" ] && NODE="$BASE_DIR/out/Release/node"
+[ -x "$NODE" ] || NODE=$(command -v node)
+
+NEW_VERSION="$("$NODE" --input-type=module <<'EOF'
+const res = await fetch('https://api.github.com/repos/nodejs/uvwasi/releases/latest');
+if (!res.ok) throw new Error(`FetchError: ${res.status} ${res.statusText}`, { cause: res });
+const { tag_name } = await res.json();
+console.log(tag_name.replace('v', ''));
+EOF
+)"
+
+CURRENT_MAJOR_VERSION=$(grep "#define UVWASI_VERSION_MAJOR" "$DEPS_DIR/uvwasi/include/uvwasi.h" | sed -n "s/^.*MAJOR \(.*\)/\1/p")
+CURRENT_MINOR_VERSION=$(grep "#define UVWASI_VERSION_MINOR" "$DEPS_DIR/uvwasi/include/uvwasi.h" | sed -n "s/^.*MINOR \(.*\)/\1/p")
+CURRENT_PATCH_VERSION=$(grep "#define UVWASI_VERSION_PATCH" "$DEPS_DIR/uvwasi/include/uvwasi.h" | sed -n "s/^.*PATCH \(.*\)/\1/p")
+CURRENT_VERSION="$CURRENT_MAJOR_VERSION.$CURRENT_MINOR_VERSION.$CURRENT_PATCH_VERSION"
+
+echo "Comparing $NEW_VERSION with $CURRENT_VERSION"
+
+if [ "$NEW_VERSION" = "$CURRENT_VERSION" ]; then
+ echo "Skipped because uvwasi is on the latest version."
+ exit 0
+fi
+
+echo "Making temporary workspace"
+
+WORKSPACE=$(mktemp -d 2> /dev/null || mktemp -d -t 'tmp')
+echo "$WORKSPACE"
+cleanup () {
+ EXIT_CODE=$?
+ [ -d "$WORKSPACE" ] && rm -rf "$WORKSPACE"
+ exit $EXIT_CODE
+}
+
+trap cleanup INT TERM EXIT
+
+UVWASI_ZIP="uvwasi-$NEW_VERSION"
+cd "$WORKSPACE"
+
+echo "Fetching UVWASI source archive..."
+curl -sL -o "$UVWASI_ZIP.zip" "https://github.com/nodejs/uvwasi/archive/refs/tags/v$NEW_VERSION.zip"
+
+echo "Moving existing GYP build file"
+mv "$DEPS_DIR/uvwasi/"*.gyp "$WORKSPACE/"
+rm -rf "$DEPS_DIR/uvwasi/"
+
+echo "Unzipping..."
+unzip "$UVWASI_ZIP.zip" -d "$DEPS_DIR/uvwasi/"
+rm "$UVWASI_ZIP.zip"
+
+mv "$WORKSPACE/"*.gyp "$DEPS_DIR/uvwasi/"
+cd "$DEPS_DIR/uvwasi/"
+
+echo "Copying new files to deps folder"
+cp -r "$UVWASI_ZIP/include" "$DEPS_DIR/uvwasi/"
+cp -r "$UVWASI_ZIP/src" "$DEPS_DIR/uvwasi/"
+cp "$UVWASI_ZIP/LICENSE" "$DEPS_DIR/uvwasi/"
+rm -rf "$UVWASI_ZIP"
+
+echo "All done!"
+echo ""
+echo "Please git add uvwasi, commit the new version:"
+echo ""
+echo "$ git add -A deps/uvwasi"
+echo "$ git commit -m \"deps: update uvwasi to $NEW_VERSION\""
+echo ""
+echo "Make sure to update the deps/uvwasi/uvwasi.gyp if any significant changes have occurred upstream"
+echo ""
+
+# The last line of the script should always print the new version,
+# as we need to add it to $GITHUB_ENV variable.
+echo "NEW_VERSION=$NEW_VERSION"